=== debian/changelog ===
pocl (3.0-6) unstable; urgency=medium

  * Update symbols file.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 04 Aug 2022 01:54:01 +0200

pocl (3.0-5) unstable; urgency=medium

  * Rebuild with GCC 12.  (Closes: #1016294)
  * Add some patches to use -latomic if needed.
  * Drop redundant pie flags to make blhc happy.
  * Update symbols file for amd64 and i386.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 03 Aug 2022 07:26:39 +0200

pocl (3.0-4) unstable; urgency=medium

  * Switch to llvm 13.  (Closes: #1001317)
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 21 Jun 2022 20:47:34 +0200

pocl (3.0-3) unstable; urgency=medium

  * Switch to llvm 12.
  * Improve nodoc build.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 19 Jun 2022 23:32:05 +0200

pocl (3.0-2) unstable; urgency=medium

  * Update symbols file.
  * Add some patches to allow overriding CPU detection.
  * Test all kernellib variants (that are supported by the host cpu) on distro
    builds.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 14 Jun 2022 14:14:47 +0200

pocl (3.0-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Use the embedded copy of the OpenCL headers for building the library.
  * Update symbols file for amd64 and i386.
  * Build with a reproducible UTC timestamp.
  * Add salsa-ci.yml.
  * Bump Standards-Version to 4.6.1, no changes needed.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 13 Jun 2022 08:57:49 +0200

pocl (1.8-4) experimental; urgency=medium

  * Add pocl-source package, to allow building e.g. the cuda device.
  * Add pocl-tests package, to allow testing pocl on the local CPU.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 11 Mar 2022 16:48:13 +0100
